import org.junit.Test;
import static org.junit.Assert.*;

public class DataIndexedWordSet {
    boolean[] exists;

    public DataIndexedWordSet() {
        exists = new boolean[1200000000];
    }

    private int convertToLetterNumber(char c) {
        return c - 'a' + 1;
    }

    private int convertToInt(String s) {
        int intRep = 0;
        for (int i = 0; i < s.length(); i += 1) {
            intRep = intRep << 5;
            intRep += convertToLetterNumber(s.charAt(i));
        }
        return intRep;
    }

    public boolean contains(String s) {
        int intRep = convertToInt(s);
        return exists[intRep];
    }

    public void put(String s) {
        int intRep = convertToInt(s);
        System.out.println(intRep);
        exists[intRep] = true;
    }

    public static void main(String[] args) {
        DataIndexedWordSet diws = new DataIndexedWordSet();
        diws.put("hello");
        diws.put("cat");
        assertTrue(diws.contains("cat"));
        assertTrue(diws.contains("hello"));
        assertFalse(diws.contains("potato"));

        System.out.println("SUCCESS!");
        diws.put("iceland");
        assertFalse(diws.contains("miceland"));

    }
} 